<template>
  <div>
    <span v-for="(link, ref) in localizedRefs" :key="ref">
      <a
        v-if="refsBase[ref]"
        class="ref-link"
        :class="{ 'dark': dark }"
        :href="refsBase[ref].baseUrl.replace('$', link)"
        :title="refsBase[ref].text"
      >
        <v-icon v-if="refsBase[ref].icon">
          {{ `mdi-${refsBase[ref].icon}` }}
        </v-icon>
        <span v-else>
          {{ refsBase[ref].text }}
        </span>
      </a>
    </span>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator';
import { REFS_BASE } from './RefsBase';

/**
 * Handles ref links for a given piece
 */
@Component
export default class RefLinks extends Vue {
  @Prop({ required: false, default: null })
  refs!: Record<string, string>;

  @Prop({
    required: false,
    default: false,
    type: Boolean,
  })
  dark!: boolean;

  localizedRefs: Record<string, string> | null = null;

  created() {
    this.localizedRefs = {};
    const locale = this.$i18n.locale.split('-')[0];
    Object.keys(this.refs).forEach((k: string) => {
      const exists = (this.localizedRefs as Record<string, string>)[k];
      const localized = this.refs[`${k}:${locale}`];
      if (localized && !exists) {
        (this.localizedRefs as Record<string, string>)[`${k}:${locale}`] = localized;
      } else if (!exists && k.includes(`:${locale}`)) {
        (this.localizedRefs as Record<string, string>)[k] = this.refs[k];
      } else if (!k.includes(':') || k.includes('musicbrainz')) {
        (this.localizedRefs as Record<string, string>)[k] = this.refs[k];
      }
    });
  }

  refsBase: Record<string, Record<string, string>> = REFS_BASE;
}
</script>

<style lang="scss" scoped>
.ref-link {
  font-size: 70%;
  color: #ccc;
  text-decoration: none;
  margin-left: .5em;
  &.dark {
    color: #333;
  }
}
</style>
